OpenShot Audio Library | OpenShotAudio: juce::Thread Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.2

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | List of all members
juce::Thread Class Referenceabstract

`#include <juce_Thread.h>`

Inheritance diagram for juce::Thread:

## Classes
class | Listener

## Public Types
enum | { realtimeAudioPriority = -1 }
using | ThreadID = void *

## Public Member Functions
| Thread (const String &threadName, size_t threadStackSize=0)
virtual | ~Thread ()
virtual void | run ()=0
void | startThread ()
void | startThread (int priority)
bool | stopThread (int timeOutMilliseconds)
bool | isThreadRunning () const
void | signalThreadShouldExit ()
bool | threadShouldExit () const
bool | waitForThreadToExit (int timeOutMilliseconds) const
void | addListener (Listener *)
void | removeListener (Listener *)
bool | setPriority (int priority)
void | setAffinityMask (uint32 affinityMask)
bool | wait (int timeOutMilliseconds) const
void | notify () const
ThreadID | getThreadId () const noexcept
const String & | getThreadName () const noexcept

## Static Public Member Functions
static void | launch (std::function< void()> functionToRun)
static bool | currentThreadShouldExit ()
static bool | setCurrentThreadPriority (int priority)
static void JUCE_CALLTYPE | setCurrentThreadAffinityMask (uint32 affinityMask)
static void JUCE_CALLTYPE | sleep (int milliseconds)
static void JUCE_CALLTYPE | yield ()
static ThreadID JUCE_CALLTYPE | getCurrentThreadId ()
static Thread *JUCE_CALLTYPE | getCurrentThread ()
static void JUCE_CALLTYPE | setCurrentThreadName (const String &newThreadName)

## Detailed Description

Encapsulates a thread.

Subclasses derive from Thread and implement the run() method, in which they do their business. The thread can then be started with the startThread() method and controlled with various other methods.

This class also contains some thread-related static methods, such as sleep(), yield(), getCurrentThreadId() etc.

See also
  CriticalSection, WaitableEvent, Process, ThreadWithProgressWindow, MessageManagerLock

Definition at line 42 of file juce_Thread.h.

## Member Typedef Documentation

## ◆ ThreadID

using juce::Thread::ThreadID = void*

A value type used for thread IDs.

See also
  getCurrentThreadId(), getThreadId()

Definition at line 304 of file juce_Thread.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Special realtime audio thread priority

This priority will create a high-priority thread which is best suited for realtime audio processing.

Currently, this priority is identical to priority 9, except when building for Android with OpenSL/Oboe support.

In this case, JUCE will ask OpenSL/Oboe to construct a super high priority thread specifically for realtime audio processing.

Note that this priority can only be set before the thread has started. Switching to this priority, or from this priority to a different priority, is not supported under Android and will assert.

For best performance this thread should yield at regular intervals and not call any blocking APIs.

See also
  startThread, setPriority, sleep, WaitableEvent

Definition at line 222 of file juce_Thread.h.

## Constructor & Destructor Documentation

## ◆ Thread()

juce::Thread::Thread | ( | const String & | threadName,
|  | size_t | threadStackSize = `0`
| ) |  |
| explicit

Creates a thread.

When first created, the thread is not running. Use the startThread() method to start it.

Parameters

  threadName | The name of the thread which typically appears in debug logs and profiles.
  threadStackSize | The size of the stack of the thread. If this value is zero then the default stack size of the OS will be used.

Definition at line 26 of file juce_Thread.cpp.

## ◆ ~Thread()

juce::Thread::~Thread | ( |  | ) |
| virtual

Destructor.

You must never attempt to delete a Thread object while it's still running - always call stopThread() and make sure your thread has stopped before deleting the object. Failing to do so will throw an assertion, and put you firmly into undefined behaviour territory.

Definition at line 31 of file juce_Thread.cpp.

## Member Function Documentation

## ◆ addListener()

void juce::Thread::addListener | ( | Listener * | listener | ) |

Add a listener to this thread which will receive a callback when signalThreadShouldExit was called on this thread.

See also
  signalThreadShouldExit, removeListener

Definition at line 247 of file juce_Thread.cpp.

## ◆ currentThreadShouldExit()

bool juce::Thread::currentThreadShouldExit | ( |  | ) |
| static

Checks whether the current thread has been told to stop running. On the message thread, this will always return false, otherwise it will return threadShouldExit() called on the current thread.

See also
  threadShouldExit

Definition at line 187 of file juce_Thread.cpp.

## ◆ getCurrentThread()

Thread *JUCE_CALLTYPE juce::Thread::getCurrentThread | ( |  | ) |
| static

Finds the thread object that is currently running.

Note that the main UI thread (or other non-JUCE threads) don't have a Thread object associated with them, so this will return nullptr.

Definition at line 165 of file juce_Thread.cpp.

Referenced by currentThreadShouldExit(), and juce::ThreadPoolJob::getCurrentThreadPoolJob().

## ◆ getCurrentThreadId()

static ThreadID JUCE_CALLTYPE juce::Thread::getCurrentThreadId | ( |  | ) |
| static

Returns an id that identifies the caller thread.

To find the ID of a particular thread object, use getThreadId().

Returns
  a unique identifier that identifies the calling thread.

See also
  getThreadId

Referenced by juce::MessageManager::currentThreadHasLockedMessageManager(), juce::ReadWriteLock::enterWrite(), juce::ReadWriteLock::exitRead(), juce::ReadWriteLock::exitWrite(), juce::ThreadLocalValue< Type >::get(), juce::MessageManager::isThisTheMessageThread(), juce::ThreadLocalValue< Type >::releaseCurrentThreadStorage(), juce::MessageManager::setCurrentThreadAsMessageThread(), setPriority(), stopThread(), juce::ReadWriteLock::tryEnterRead(), juce::ReadWriteLock::tryEnterWrite(), and waitForThreadToExit().

## ◆ getThreadId()

Thread::ThreadID juce::Thread::getThreadId | ( |  | ) | const
| noexcept

Returns the ID of this thread.

That means the ID of this thread object - not of the thread that's calling the method. This can change when the thread is started and stopped, and will be invalid if the thread's not actually running.

See also
  getCurrentThreadId

Definition at line 170 of file juce_Thread.cpp.

Referenced by setPriority(), stopThread(), and waitForThreadToExit().

## ◆ getThreadName()

const String & juce::Thread::getThreadName | ( |  | ) | const
| inlinenoexcept

Returns the name of the thread. This is the name that gets set in the constructor.

Definition at line 333 of file juce_Thread.h.

## ◆ isThreadRunning()

bool juce::Thread::isThreadRunning | ( |  | ) | const

Returns true if the thread is currently active

Definition at line 160 of file juce_Thread.cpp.

Referenced by juce::dsp::Convolution::Pimpl::processFifo(), setPriority(), stopThread(), waitForThreadToExit(), and ~Thread().

## ◆ launch()

void juce::Thread::launch | ( | std::function< void()> | functionToRun | ) |
| static

Invokes a lambda or function on its own thread.

This will spin up a Thread object which calls the function and then exits. Bear in mind that starting and stopping a thread can be a fairly heavyweight operation, so you might prefer to use a ThreadPool if you're kicking off a lot of short background tasks.

Also note that using an anonymous thread makes it very difficult to interrupt the function when you need to stop it, e.g. when your app quits. So it's up to you to deal with situations where the function may fail to stop in time.

Definition at line 326 of file juce_Thread.cpp.

## ◆ notify()

void juce::Thread::notify | ( |  | ) | const

Wakes up the thread.

If the thread has called the wait() method, this will wake it up.

See also
  wait

Definition at line 305 of file juce_Thread.cpp.

Referenced by juce::TimeSliceThread::addTimeSliceClient(), juce::TimeSliceThread::moveToFrontOfQueue(), and stopThread().

## ◆ removeListener()

void juce::Thread::removeListener | ( | Listener * | listener | ) |

Removes a listener added with addListener.

Definition at line 252 of file juce_Thread.cpp.

## ◆ run()

virtual void juce::Thread::run | ( |  | ) |
| pure virtual

Must be implemented to perform the thread's actual code.

Remember that the thread must regularly check the threadShouldExit() method whilst running, and if this returns true it should return from the run() method as soon as possible to avoid being forcibly killed.

See also
  threadShouldExit, startThread

Implemented in juce::TimeSliceThread.

## ◆ setAffinityMask()

void juce::Thread::setAffinityMask | ( | uint32 | affinityMask | ) |

Sets the affinity mask for the thread.

This will only have an effect next time the thread is started - i.e. if the thread is already running when called, it'll have no effect.

See also
  setCurrentThreadAffinityMask

Definition at line 294 of file juce_Thread.cpp.

## ◆ setCurrentThreadAffinityMask()

static void JUCE_CALLTYPE juce::Thread::setCurrentThreadAffinityMask | ( | uint32 | affinityMask | ) |
| static

Changes the affinity mask for the caller thread.

This will change the affinity mask for the thread that calls this static method.

See also
  setAffinityMask

## ◆ setCurrentThreadName()

static void JUCE_CALLTYPE juce::Thread::setCurrentThreadName | ( | const String & | newThreadName | ) |
| static

Changes the name of the caller thread.

Different OSes may place different length or content limits on this name.

## ◆ setCurrentThreadPriority()

bool juce::Thread::setCurrentThreadPriority | ( | int | priority | ) |
| static

Changes the priority of the caller thread.

Similar to setPriority(), but this static method acts on the caller thread. May return false if for some reason the priority can't be changed.

See also
  setPriority

Definition at line 289 of file juce_Thread.cpp.

Referenced by setPriority().

## ◆ setPriority()

bool juce::Thread::setPriority | ( | int | priority | ) |

Changes the thread's priority.

May return false if for some reason the priority can't be changed.

Parameters

  priority | the new priority, in the range 0 (lowest) to 10 (highest). A priority of 5 is normal.

See also
  realtimeAudioPriority

Definition at line 258 of file juce_Thread.cpp.

Referenced by startThread().

## ◆ signalThreadShouldExit()

void juce::Thread::signalThreadShouldExit | ( |  | ) |

Sets a flag to tell the thread it should stop.

Calling this means that the threadShouldExit() method will then return true. The thread should be regularly checking this to see whether it should exit.

If your thread makes use of wait(), you might want to call notify() after calling this method, to interrupt any waits that might be in progress, and allow it to reach a point where it can exit.

See also
  threadShouldExit, waitForThreadToExit

Definition at line 176 of file juce_Thread.cpp.

Referenced by juce::InterprocessConnectionServer::stop(), and stopThread().

## ◆ sleep()

static void JUCE_CALLTYPE juce::Thread::sleep | ( | int | milliseconds | ) |
| static

Suspends the execution of the current thread until the specified timeout period has elapsed (note that this may not be exact).

The timeout period must not be negative and whilst sleeping the thread cannot be woken up so it should only be used for short periods of time and when other methods such as using a WaitableEvent or CriticalSection are not possible.

Referenced by juce::TemporaryFile::deleteTemporaryFile(), juce::TemporaryFile::overwriteTargetFileWithTemporary(), juce::BufferingAudioSource::prepareToPlay(), juce::MessageManager::runDispatchLoop(), juce::AudioDeviceManager::setCurrentAudioDeviceType(), juce::AudioTransportSource::stop(), juce::Time::waitForMillisecondCounter(), juce::ChildProcess::waitForProcessToFinish(), and waitForThreadToExit().

## ◆ startThread() [1/2]

void juce::Thread::startThread | ( |  | ) |

Starts the thread running.

This will cause the thread's run() method to be called by a new thread. If this thread is already running, startThread() won't do anything.

See also
  stopThread

Definition at line 122 of file juce_Thread.cpp.

Referenced by juce::NetworkServiceDiscovery::Advertiser::Advertiser(), juce::NetworkServiceDiscovery::AvailableServiceList::AvailableServiceList(), juce::InterprocessConnectionServer::beginWaitingForSocket(), juce::dsp::Convolution::Pimpl::processFifo(), and startThread().

## ◆ startThread() [2/2]

void juce::Thread::startThread | ( | int | priority | ) |

Starts the thread with a given priority.

Launches the thread with a given priority, where 0 = lowest, 10 = highest. If the thread is already running, its priority will be changed.

See also
  startThread, setPriority, realtimeAudioPriority

Definition at line 136 of file juce_Thread.cpp.

## ◆ stopThread()

bool juce::Thread::stopThread | ( | int | timeOutMilliseconds | ) |

Attempts to stop the thread running.

This method will cause the threadShouldExit() method to return true and call notify() in case the thread is currently waiting.

Hopefully the thread will then respond to this by exiting cleanly, and the stopThread method will wait for a given time-period for this to happen.

If the thread is stuck and fails to respond after the timeout, it gets forcibly killed, which is a very bad thing to happen, as it could still be holding locks, etc. which are needed by other parts of your program.

Parameters

  timeOutMilliseconds | The number of milliseconds to wait for the thread to finish before killing it by force. A negative value in here will wait forever.

Returns
  true if the thread was cleanly stopped before the timeout, or false if it had to be killed by force.

See also
  signalThreadShouldExit, threadShouldExit, waitForThreadToExit, isThreadRunning

Definition at line 213 of file juce_Thread.cpp.

Referenced by juce::dsp::Convolution::Pimpl::initProcessing(), juce::InterprocessConnectionServer::stop(), ~Thread(), and juce::TimeSliceThread::~TimeSliceThread().

## ◆ threadShouldExit()

bool juce::Thread::threadShouldExit | ( |  | ) | const

Checks whether the thread has been told to stop running.

Threads need to check this regularly, and if it returns true, they should return from their run() method at the first possible opportunity.

See also
  signalThreadShouldExit, currentThreadShouldExit

Definition at line 182 of file juce_Thread.cpp.

Referenced by juce::TimeSliceThread::run().

## ◆ wait()

bool juce::Thread::wait | ( | int | timeOutMilliseconds | ) | const

Suspends the execution of this thread until either the specified timeout period has elapsed, or another thread calls the notify() method to wake it up.

A negative timeout value means that the method will wait indefinitely.

Returns
  true if the event has been signalled, false if the timeout expires.

Definition at line 300 of file juce_Thread.cpp.

Referenced by juce::TimeSliceThread::run().

## ◆ waitForThreadToExit()

bool juce::Thread::waitForThreadToExit | ( | int | timeOutMilliseconds | ) | const

Waits for the thread to stop. This will wait until isThreadRunning() is false or until a timeout expires.

Parameters

  timeOutMilliseconds | the time to wait, in milliseconds. If this value is less than zero, it will wait forever.

Returns
  true if the thread exits, or false if the timeout expires first.

Definition at line 195 of file juce_Thread.cpp.

Referenced by stopThread().

## ◆ yield()

static void JUCE_CALLTYPE juce::Thread::yield | ( |  | ) |
| static

Yields the current thread's CPU time-slot and allows a new thread to run.

If there are no other threads of equal or higher priority currently running then this will return immediately and the current thread will continue to run.

Referenced by juce::SpinLock::enter(), juce::BufferingAudioReader::readSamples(), and juce::Time::waitForMillisecondCounter().

The documentation for this class was generated from the following files:

- juce_Thread.h
- juce_Thread.cpp